## mingw-w64-qt6-serialbus-6.9.2-1.src.tar.zst

=== src/serialbus/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

#####################################################################
## SerialBus Module:
#####################################################################

qt_internal_add_module(SerialBus
    PLUGIN_TYPES canbus
    SOURCES
        qcanbus.cpp qcanbus.h
        qcanbusdevice.cpp qcanbusdevice.h qcanbusdevice_p.h
        qcanbusdeviceinfo.cpp qcanbusdeviceinfo.h qcanbusdeviceinfo_p.h
        qcanbusfactory.cpp qcanbusfactory.h
        qcanbusframe.cpp qcanbusframe.h
        qcancommondefinitions.cpp qcancommondefinitions.h
        qcandbcfileparser.cpp qcandbcfileparser.h qcandbcfileparser_p.h
        qcanframeprocessor.cpp qcanframeprocessor.h qcanframeprocessor_p.h
        qcanmessagedescription.cpp qcanmessagedescription.h qcanmessagedescription_p.h
        qcansignaldescription.cpp qcansignaldescription.h qcansignaldescription_p.h
        qcanuniqueiddescription.cpp qcanuniqueiddescription.h qcanuniqueiddescription_p.h
        qmodbus_symbols_p.h
        qmodbusadu_p.h
        qmodbusclient.cpp qmodbusclient.h qmodbusclient_p.h
        qmodbuscommevent_p.h
        qmodbusdataunit.cpp qmodbusdataunit.h
        qmodbusdevice.cpp qmodbusdevice.h qmodbusdevice_p.h
        qmodbusdeviceidentification.cpp qmodbusdeviceidentification.h
        qmodbuspdu.cpp qmodbuspdu.h
        qmodbusreply.cpp qmodbusreply.h
        qmodbusserver.cpp qmodbusserver.h qmodbusserver_p.h
        qmodbustcpclient.cpp qmodbustcpclient.h qmodbustcpclient_p.h
        qmodbustcpserver.cpp qmodbustcpserver.h qmodbustcpserver_p.h
        qtserialbusglobal.h
    LIBRARIES
        Qt::CorePrivate
    PUBLIC_LIBRARIES
        Qt::Core
        Qt::Network  # TODO: QTBUG-86533 workaround, Qt::Network should be moved to LIBRARIES
    PRIVATE_MODULE_INTERFACE
        Qt::CorePrivate
        Qt::Network
)

## Scopes:
#####################################################################

qt_internal_extend_target(SerialBus CONDITION QT_FEATURE_modbus_serialport
    SOURCES
        qmodbusrtuserialclient.cpp qmodbusrtuserialclient.h qmodbusrtuserialclient_p.h
        qmodbusrtuserialserver.cpp qmodbusrtuserialserver.h qmodbusrtuserialserver_p.h
    PUBLIC_LIBRARIES
        Qt::SerialPort
    PRIVATE_MODULE_INTERFACE
        Qt::SerialPort
)

qt_internal_add_docs(SerialBus
    doc/qtserialbus.qdocconf
)

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=qt6-serialbus
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}"
         "${MINGW_PACKAGE_PREFIX}-${_realname}-debug")
_qtver=6.9.2
pkgver=${_qtver/-/}
pkgrel=1
pkgdesc='Qt module for general purpose serial bus access (mingw-w64)'
arch=(any)
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://www.qt.io'
msys2_repository_url="https://code.qt.io/cgit/qt/qtserialbus.git"
msys2_references=(
  'archlinux: qt6-serialbus'
  "cpe: cpe:/a:qt:qt"
)
license=('spdx:LGPL-3.0-only WITH Qt-GPL-exception-1.0 AND BSD-3-Clause AND GFDL-1.3-no-invariants-only AND GPL-2.0-only AND GPL-3.0-only')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-qt6-serialport"
             "rsync")
_pkgfn="${_realname/6-/}-everywhere-src-${_qtver}"
source=("https://download.qt.io/official_releases/qt/${pkgver%.*}/${_qtver}/submodules/${_pkgfn}.tar.xz"
        "001-appending-qt6-to-remove-qt5-conflict.patch")
sha256sums=('951e07c2faf4476c75a59af96b40eeedbdf1a1c5c354c2825b59eaf3594f2a76'
            '06d8b31a6022e43a5daeb71f083d8344e18c8234c6f7988bbc0a49f14bd2f539')

# Helper macros to help make tasks easier #
apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd $srcdir/${_pkgfn}

  apply_patch_with_msg \
    001-appending-qt6-to-remove-qt5-conflict.patch
}

build() {
  mkdir -p build-${MSYSTEM} && cd build-${MSYSTEM}

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    --log-level=STATUS \
    -GNinja \
    -DCMAKE_BUILD_TYPE=RelWithDebInfo \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    ../${_pkgfn}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package_qt6-serialbus() {
  depends=("${MINGW_PACKAGE_PREFIX}-qt6-serialport")
  groups=("${MINGW_PACKAGE_PREFIX}-qt6")

  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install build-${MSYSTEM}

  # Seperate debug-info files
  rsync -armR --remove-source-files --include="*/" --include="*.debug" --exclude="*" --prune-empty-dirs "${pkgdir}"/.${MINGW_PREFIX} "${srcdir}"/${MSYSTEM}-debug/

  install -d "$pkgdir${MINGW_PREFIX}"/share/licenses/${_realname}
  install -Dm644 $_pkgfn/LICENSES/* -t "$pkgdir${MINGW_PREFIX}"/share/licenses/${_realname}
}

package_qt6-serialbus-debug() {
  depends=("${MINGW_PACKAGE_PREFIX}-qt6-serialport-debug"
           "${MINGW_PACKAGE_PREFIX}-${_realname}")
  groups=("${MINGW_PACKAGE_PREFIX}-qt6-debug")
  options=('!strip')

  cp -rf "${srcdir}"/${MSYSTEM}-debug${MINGW_PREFIX} "${pkgdir}"/
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;
